/**********
This library is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the
Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)

This library is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
more details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
**********/
// "liveMedia"
// Copyright (c) 1996-2012 Live Networks, Inc.  All rights reserved.
// A 'ServerMediaSubsession' object that creates new, unicast, "RTPSink"s
// on demand, from an incoming UDP MPEG2TransportStream stream
//Implementation
#include "MPEG2TransportUDPServerMediaSubsession.hh"
#include "SimpleRTPSink.hh"
#include "GroupsockHelper.hh"
MPEG2TransportUDPServerMediaSubsession*
MPEG2TransportUDPServerMediaSubsession::createNew(UsageEnvironment& env,
                char const* inputAddressStr,
                Port const inputPort,
                unsigned char const inputTTL,
                Boolean reuseFirstSource){
    return new MPEG2TransportUDPServerMediaSubsession(env,inputAddressStr,inputPort,inputTTL,reuseFirstSource);
    
}

MPEG2TransportUDPServerMediaSubsession
::MPEG2TransportUDPServerMediaSubsession(UsageEnvironment& env,
                                         char const* inputAddressStr,
                                         Port const inputPort,
                                         unsigned char const inputTTL,
                                         Boolean reuseFirstSource)
    :OnDemandServerMediaSubsession(env,reuseFirstSource),fEnv(env),fInputPort(inputPort),fInputAddressStr(inputAddressStr),
fInputTTL(inputTTL){
    
}

MPEG2TransportUDPServerMediaSubsession
::~MPEG2TransportUDPServerMediaSubsession(){
    
}
FramedSource* MPEG2TransportUDPServerMediaSubsession
::createNewStreamSource(unsigned/* clientSessionId*/, unsigned& estBitrate){
      estBitrate = 5000;
      struct in_addr inputAddress;
      if(!strcmp(fInputAddressStr,"0"))
         inputAddress.s_addr = 0;
      else
         inputAddress.s_addr = our_inet_addr(fInputAddressStr);
      
      Groupsock *inputUDPsock = new Groupsock (envir(), inputAddress, fInputPort, fInputTTL);
      BasicUDPSource* UDPSource = BasicUDPSource::createNew(envir(),inputUDPsock);
    return MPEG2TransportStreamFramer::createNew(envir(),UDPSource);
}
RTPSink* MPEG2TransportUDPServerMediaSubsession
::createNewRTPSink(Groupsock* rtpGroupsock,
                                        unsigned char /*rtpPayloadTypeIfDynamic*/,
                                        FramedSource* /*inputSource*/){
    return SimpleRTPSink::createNew(envir(),rtpGroupsock,
				  33, 90000, "video", "MP2T",
				  1, True, False /*no 'M' bit*/);
}